-- gamemode for LOVE to handle the game itself
gamemode = {}

ROT=require 'libraries/rotLove/rotLove'

require 'class.Area'
require 'class.Map'
require 'class.Player'
local GUI = require 'class.PlayerGUI'

--[[require 'engine.class'
module("Game", package.seeall, class.make)]]

function gamemode.load()
  --list of entities
    entities = {}

    --load tiles
    Map:loadTiles()
    
    --area = Area.new()
    Area:generate(1, 20, 20)

    player = Player.new()

    Map:setupMapView()

    --load scheduler
    s  =ROT.Scheduler.Action:new()
    --put entities into scheduler
    for i, e in ipairs(entities) do
      s:add(i,true,i-1) 
    end
end
--to use by debug drawer
draw_y = 200

--drawing
function draw_map()
   Map:display()
end

function draw_GUI(player)
  GUI:draw_GUI(player)
end

function drawdebug()
  GUI:draw_schedule()
end

--shorthand
function celltotile(x, y)
    return Map:convertTerraintoTile(x,y)
end

function gamemode.draw()
    love.graphics.setColor(255, 255, 255)
    draw_map()
    if player then draw_GUI(player) end
    if player then drawdebug() end
    --f:draw()
end


--input
function gamemode.keypressed(k)
    --do nothing if locked
    if game_locked == true then 
      print("We're locked, not responding to player input keys")
      return end

    if k == "left" then
      player:PlayerMove("left")
       --[[map_x = map_x-1
       if map_x -1 < 0 then map_x = 0 end
       print("Pressed left key, map_x: ", map_x)]]
    elseif k == "right" then
        player:PlayerMove("right")
       --[[ map_x = map_x +1
        if map_x > map_display_w then map_x = map_display_w end
        print("Pressed right key, map_x: ", map_x)]]
    elseif k == "down" then
        player:PlayerMove("down")
        --[[map_y = map_y+1
        if map_y > map_h+map_display_h then map_y = map_h+map_display_h end
        print("Pressed down key, map_y: ", map_y)]]
    elseif k == "up" then
        player:PlayerMove("up")
        --[[map_y = map_y-1
        if map_y < 0 then map_y = 0 end
        print("Pressed up key, map_y: ", map_y)]]
    end
end

--update!
function gamemode.update()
  rounds()
end

function rounds()
      love.timer.sleep(.5)
    --gets the number
    c  =s:next()
    --test 
    local ent = entities[c]
    local name = ent.name

    dur=10 --test
    s:setDuration(dur)
    
    --lock and unlock
    if not ent.player == true then game_lock() print("Locking game because not our turn") end
    --simple unlock
    if ent.player == true then game_locked = false print("Unlocked on our turn") end

    --used by debug display
    schedule = "TURN: "..ent.name.." ["..c.."] for "..dur.." units of time"
    if ent.player == true then schedule = "PLAYER "..schedule end
    draw_y= draw_y< 400 and draw_y +10 or 200
end

--turn-basedness
function game_lock()
  --self._locked = true
  game_locked = true
end

function game_unlock()
  if game_locked == false then return end
  game_locked = false

  --if self._locked == false then return end
  --self._locked = false

  for i=1,#entities do
    local item = entities[i]
    if item['act'] then item:act() end
  end
end

--return Game